<?php

namespace GopNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;

class PercentageAndStructureForBudgetController {
    protected $crudService;
    
    public function __construct($connection, $environment, $service, $util, $crudService) {
        $this->connection   = $connection;
        $this->environment  = $environment;
        $this->service      = $service;
        $this->util         = $util;
        $this->crudService	= $crudService;
    }
    
    public function structureItemChange(Request\DataSet $request, Response $response) {
      $data = $request->getDataSet()->getRows();
      
      try {
        $this->service->beginTransaction();
        foreach ($data as $row) {
          $params = [
            "VRPERCITEMGOP"   => $row["VRPERCITEMGOP"],
            "CDFILIAL"        => $row["CDFILIAL"],
            "NRSEQITEMORCA"   => $row["NRSEQITEMORCA"],
            "CDOPERADOR"      => $this->environment->getCdOperador(),
            "NRORG"           => $this->environment->getNrorg()
          ];
          $this->service->updateOperationalItem($params, $row["NRSEQ"]);
        }
        $this->service->commit();
      } catch (\Exception $ex) {
          $this->service->rollback();
          $response->setError(new Error($ex->getMessage(), 500));
      }
  }
}